Ginkgo: gko::experimental::reorder::Mc64< ValueType, IndexType > Class Template Reference

| Ginkgo Generated from branch based on main. Ginkgo version 1.11.0 A numerical linear algebra library targeting many-core architectures

Loading...
Searching...
No Matches
gko::experimental::reorder::Mc64< ValueType, IndexType > Class Template Referencefinal

MC64 is an algorithm for permuting large entries to the diagonal of a sparse matrix. More...

`#include <ginkgo/core/reorder/mc64.hpp>`

Inheritance diagram for gko::experimental::reorder::Mc64< ValueType, IndexType >:
[legend]
Collaboration diagram for gko::experimental::reorder::Mc64< ValueType, IndexType >:
[legend]

## Classes
struct | parameters_type

## Public Types
using | value_type = ValueType
using | index_type = IndexType
using | result_type = Composition<value_type>
using | matrix_type = matrix::Csr<value_type, index_type>
Public Types inherited from gko::EnablePolymorphicAssignment< Mc64< default_precision, int32 > >
using | result_type

## Public Member Functions
const parameters_type & | get_parameters () const
| Returns the parameters used to construct the factory.
std::unique_ptr< result_type > | generate (std::shared_ptr< const LinOp > system_matrix) const
| Creates a new product from the given components.
Public Member Functions inherited from gko::EnablePolymorphicAssignment< Mc64< default_precision, int32 > >
void | convert_to (result_type *result) const override
void | move_to (result_type *result) override

## Static Public Member Functions
static parameters_type | build ()
| Creates a new parameter_type to set up the factory.

## Friends
class | EnablePolymorphicObject< Mc64< ValueType, IndexType >, LinOpFactory >
class | enable_parameters_type< parameters_type, Mc64< ValueType, IndexType > >

## Detailed Description

template<typename ValueType = default_precision, typename IndexType = int32>
class gko::experimental::reorder::Mc64< ValueType, IndexType >

MC64 is an algorithm for permuting large entries to the diagonal of a sparse matrix.

This approach can increase numerical stability of e.g. an LU factorization without pivoting. Under the assumption of working on a nonsingular square matrix, the algorithm computes a minimum weight perfect matching on a weighted edge bipartite graph of the matrix. It is described in detail in "On Algorithms for Permuting Large Entries to the Diagonal of a Sparse Matrix" (Duff, Koster, 2001, DOI: 10.1137/S0895479899358443). There are two strategies for choosing the weights supported:

- Maximizing the product of the absolute values on the diagonal. For this strategy, the weights are computed as if and otherwise. Here, a_i is the maximum absolute value in row i of the matrix A. In this case, the implementation computes a row permutation P and row and column scaling coefficients L and R such that the matrix P*L*A*R has values with unity absolute value on the diagonal and smaller or equal entries everywhere else.
- Maximizing the sum of the absolute values on the diagonal. For this strategy, the weights are computed as if and otherwise. In this case, no scaling coefficients are computed.

This class creates a Combination of two ScaledPermutations representing the row and column permutation and scaling factors computed by this algorithm.

Template Parameters

  ValueType | Type of the values of all matrices used in this class
  IndexType | Type of the indices of all matrices used in this class

## Member Function Documentation

## ◆ generate()

template<typename ValueType = default_precision, typename IndexType = int32>

std::unique_ptr< result_type > gko::experimental::reorder::Mc64< ValueType, IndexType >::generate | ( | std::shared_ptr< const LinOp > | system_matrix | ) | const

Creates a new product from the given components.

The method will create an ComponentsType object from the arguments of this method, and pass it to the generate_impl() function which will create a new AbstractProductType.

Template Parameters

  Args | types of arguments passed to the constructor of ComponentsType

Parameters

  args | arguments passed to the constructor of ComponentsType

Returns
  an instance of AbstractProductType

Note
  This function overrides the default LinOpFactory::generate to return a Permutation instead of a generic LinOp, which would need to be cast to ScaledPermutation again to access its indices. It is only necessary because smart pointers aren't covariant.

## ◆ get_parameters()

template<typename ValueType = default_precision, typename IndexType = int32>

const parameters_type & gko::experimental::reorder::Mc64< ValueType, IndexType >::get_parameters | ( |  | ) | const
| inline

Returns the parameters used to construct the factory.

Returns
  the parameters used to construct the factory.

The documentation for this class was generated from the following file:

- ginkgo/core/reorder/mc64.hpp